* ------------------------------------------------------------------- A09_A32
      Program A09_A32

* Replaces Ascii character 09 with Ascii character 32 (blank)

* Obtains files from a control file, one file per line

* Here is a sample control file:
*!Control file for program A09_A32
*! reformats a unix ascii file to a pc ascii file
*v1x0300.usc
*V1X0600.USC
*V1X0900.USC
*V1X1100.USC
*V1X9100.USC
*stop

* Dates: 06/01/01 - Written by D. Boore, patterned after unix2pc

      character c_in*1, f_in*80, f_out*80, f_scr*80, c_stop*4

      character f_ctl*40, buf*80, comment(20)*80
      logical f_ctl_exist, f_in_exist, f_scr_exist, f_out_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') stop
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skipcmnt(nu_ctl, comment, ncomments)

222   continue
      
      buf = ' '
      read(nu_ctl,'(a)') buf
      call trim_c(buf, nc_buf)
      c_stop = ' '
      c_stop = buf(1:4)
      call upstr(c_stop)
      if (c_stop .eq. 'STOP') then
        close(nu_ctl)
        stop
      end if

      f_in = ' '
      f_in = buf(1:nc_buf)
      call trim_c(f_in,nc_f_in)
* Check for existence of f_in:
      f_in_exist = .false.
      inquire(file=f_in, exist=f_in_exist)

      write(*,'(a)') ' f_in, f_in_exist = '//f_in
      write(*,*) f_in_exist

      if (.not. f_in_exist) then
        write(*,'(a)') ' File '//f_in(1:nc_buf)//
     :   ' does not exist; returning to control file'
        go to 222
      end if

      write(*,'(2a)') ' Reformatting file ', f_in(1:nc_buf)

      call get_lun(nu_in)
      open(unit=nu_in,file=f_in(1:nc_buf), position='rewind',
     :     access='transparent',form='unformatted',
     :     status='unknown')

* Check for existence of f_scr, and delete if it exists:
      f_scr = ' '
      f_scr = 'scratch.out'
      call trim_c(f_scr,nc_f_scr)
      f_scr_exist = .false.
      inquire(file=f_scr, exist=f_scr_exist)
      if (f_scr_exist) then
        call system('del '//f_scr(1:nc_f_scr))
      end if

      call get_lun(nu_scr)
      open(unit=nu_scr,file=f_scr, position='rewind',
     :     access='transparent',form='unformatted',
     :     status='unknown')

1000  continue
      c_in = ' '
      read(nu_in, end = 2000) c_in
      if (ichar(c_in) .eq. 09) then
        write(nu_scr) char(32)
      else
        write(nu_scr) c_in
      end if
      goto 1000
2000  continue

      close(nu_in)
      close(nu_scr)

* Copy scratch.out to f_out, delete scratch.out:

      f_out = f_in(1:nc_f_in)
      call trim_c(f_out,nc_f_out)
      
      f_out_exist = .false.
      inquire(file=f_out, exist=f_out_exist)
      if (f_out_exist) then
        call system('del '//f_out(1:nc_f_out))
      end if
      call system('copy '//f_scr(1:nc_f_scr)//' '//f_out(1:nc_f_out))
      call system('del '//f_scr(1:nc_f_scr))

      go to 222

      end
* ------------------------------------------------------------------- A09_A32

      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\upstr.for'
      include '\forprogs\skipcmnt.for'

