* ---------------------------------------------------------------- band_avg
      Program Band_Avg

* Computes averages of spectra between specified bands.

* The next line is the first line in a sample control file:
*!Control file for program Band_Avg
*!Output file name:
* band_avg.col
*!Use first or last part of file name for column header (F, L)?
* F
*!band (Hz):
* 0.5 2.5
*!Hz?
* Y
*!N lines to skip to get to data
* 1
*!N columns to read, columns for predictor and response variables 
*!  (for files made using blpadflt, period is in column 1 and sd, pv, pa, rv, 
*!  aa are in columns 2, 3, 4, 5, 6, respectively)
* 6 1 3
*!Is x freq?
* N
*!file ("STOP" in any column, any case, to quit)
*1397c_u.smc.rm_v0_alc_p02.r.col
*1731a_u.smc.rm_v0_alc_p02.r.col
*1734a_u.smc.rm_v0_alc_p02.r.col
*stop

* Dates: 12/12/03 - Written by D. Boore, based on psv_avg
 
      character comments(200)*80, buf*80, bufuc*4
      character is_band_freq*1, is_x_freq*1
      real x(50000), y(50000), dum(10)
      character f_in*80, f_out*80
      character header(26)*12, damp_c*2, col1*30

      integer nper

      character f_ctl*40
      logical f_ctl_exist, use_first

      twopi = 2.0*4.0*atan(1.)

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = band_avg.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') f_ctl = 'band_avg.ctl'
        call trim_c(f_ctl, nc_f_ctl)
        inquire(file=f_ctl(1:nc_f_ctl), exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl(1:nc_f_ctl),status='unknown')
      write(*,'(a)') ' f_ctl = '//f_ctl(1:nc_f_ctl)

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      f_out = ' '
      read(nu_ctl,'(a)') f_out
      call trim_c(f_out, nc_f_out)
      call get_lun(nu_out)
      open(unit=nu_out,file=f_out(1:nc_f_out),status='unknown')
      write(*,'(a)') ' f_out = '//f_out(1:nc_f_out)
      write(nu_out,'(27x,a, 3x,a, 3x,a, 2x,a, 2x,a, 
     :    8x,a, 6x,a, 3x,a, 4x,a)')
     :   'file', 'bl_Hz', 'bh_Hz', 'bl_Sec', 'bh_Sec',
     :   'yavg', 'sdyavg', 'yavg_area', 'yavg_log' 


* Read variable specifying what part of file name is used in column header:
      call skipcmnt(nu_ctl,comments,nc_cmnts)
      buf = ' '
      read(nu_ctl, '(a)') buf
      call trim_c(buf,nc_buf)
      bufuc = ' '
      bufuc = buf(1:1)
      call upstr(bufuc)
      if (bufuc(1:1) .eq. 'F') then
        use_first = .true.
      else
        use_first = .false.
      end if

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) band_low, band_high

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      buf = ' '
      read(nu_ctl,'(a)') buf
      call trim_c(buf, nc_buf)
      bufuc = ' '
      bufuc = buf(1:1)
      call upstr(bufuc)
      is_band_freq = ' '
      is_band_freq = bufuc(1:1)

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) n_lines_to_skip
      write(*,'(a)') ' n_lines_to_skip = '
      write(*,*)       n_lines_to_skip

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      read(nu_ctl,*) ncol2read, icolx, icoly
      write(*,'(a)') ' ncol2read, icolx, icoly = '
      write(*,*)       ncol2read, icolx, icoly

      call skipcmnt(nu_ctl,comments,nc_cmnts)
      buf = ' '
      read(nu_ctl,'(a)') buf
      call trim_c(buf, nc_buf)
      bufuc = ' '
      bufuc = buf(1:1)
      call upstr(bufuc)
      is_x_freq = ' '
      is_x_freq = bufuc(1:1)

      call skipcmnt(nu_ctl,comments,nc_cmnts)

1000  continue

      buf = ' '
      read(nu_ctl,'(a)') buf
      call trim_c(buf,nc_buf)

      bufuc = ' '
      bufuc = buf(1:4)
      call upstr(bufuc)
      if(bufuc(1:4) .eq. 'STOP') then
         close(nu_ctl)
         close(nu_out)
         stop
      end if

      f_in = ' '
      f_in = buf(1:nc_buf)
      call trim_c(f_in, nc_f_in)
      call get_lun(nu_in)
      open(unit=nu_in,file=f_in(1:nc_f_in),status='unknown')
      write(*,'(a)') '   f_in = '//f_in(1:nc_f_in)

* Read the input file:

      nx = 0

      call skip(nu_in,n_lines_to_skip)  !   skip to data

888   continue

      
*      read(nu_in,*, end = 444) (dum(i), i=1, 2)
      read(nu_in,*, end = 444) (dum(i), i=1, ncol2read)

      nx = nx + 1

      x(nx) = dum(icolx)
      y(nx) = dum(icoly)

      go to 888
444   continue
      close(nu_in)

* Compute averages and write output:
      if (is_x_freq .eq. is_band_freq) then
        xlow = band_low
        xhigh = band_high
      else
        xlow = 1.0/band_high
        xhigh = 1.0/band_low
      end if                

      call avg_xlxh(y,x,nx, xlow,xhigh,yavg,sdyavg, 
     :                    yavg_area, yavg_log)

      if (is_band_freq .eq. 'Y') then
        freq_low = band_low
        freq_high = band_high
        per_low = 1.0/band_high
        per_high = 1.0/band_low
      else
        per_low = band_low
        per_high = band_high
        freq_low = 1.0/band_high
        freq_high = 1.0/band_low
      end if

*      write(nu_out,'(a,1x,f7.3,1x,f7.3, a)') 
*     :    ' Band: ', freq_low, freq_high, ' Hz'  
*      write(nu_out,'(a,1x,f7.3,1x,f7.3, a)') 
*     :    ' Band: ', per_low, per_high, ' Sec'  

      if (use_first) then
        col1 = ' '
        n1 = max0(1, 30-nc_f_in+1)
        nf2 = min0(30, nc_f_in)
        col1(n1:30) = f_in(1:nf2)
      else
        col1 = ' '
        n1 = max0(1, 30-nc_f_in+1)
        nf1 = max0(1, nc_f_in - 30 + 1)
        col1(n1:30) = f_in(nf1:nc_f_in)
      end if

      write(nu_out,'(1x,a30, 4(1x,f7.3), 0p, 4(1x,e11.4))') 
     :  col1, freq_low, freq_high, per_low, per_high,
     :  yavg, sdyavg, yavg_area, yavg_log 


      goto 1000 ! go back for another file

      end
* ---------------------------------------------------------------- band_avg

* ---------------------------------------------------------------- avg_xlxh
      subroutine avg_xlxh(y,x,ny, xlow,xhigh,yavg,sdyavg, 
     :                    yavg_area, yavg_log)

* Computes average of y from xlow to xhigh.
 
* Dates:  12/12/03 - Written by D. Boore, patterned after getavgsa
  
      real y(*), x(*)
      
      real work(:)
      allocatable work
      
 
* Get limits:

      call locate(x, ny, xlow, nlowm1)
      call locate(x, ny, xhigh, nhigh)
      nlow = nlowm1 + 1

 
* Now compute the averages:

* Normal average:

      navg = nhigh - nlow + 1
      
      allocate (work(navg))
      
      do i = 1, navg
        work(i) = y(i+nlowm1)
      end do
      call avevar(work,navg,avg,var)
      yavg = avg
      sdyavg = sqrt(var/navg)
      
      do i = 1, navg
        work(i) = alog10(y(i+nlowm1))
      end do
      call avevar(work,navg,avg,var)
      yavg_log = 10.0**avg
      
      deallocate (work)
      
      
* Average using the area:
     
      area = 0.0
      do i = nlow, nhigh-1
        area = area + 0.5*(y(i)+y(i+1))*(x(i+1)-x(i))
      end do
      yavg_area = area/(x(nhigh)-x(nlow))
      
      return
      end
* ---------------------------------------------------------------- avg_xlxh
  
  
  
      include '\forprogs\upstr.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\skip.for'
      include '\forprogs\get_lun.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\avevar.for'
      include '\forprogs\locate.for'
!      include '\forprogs\avg_xlxh.for'

