      Program Env2Avg

* Reads a series of files containing envelopes (made by 
* \forprogs\env2phs) and computes the average of the envelopes 

* Dates: 06/21/02 - Written by D. Boore, based on PhD2Hist

      real time_1(:), env(:), avg(:)
      allocatable :: time_1, env, avg

      character buf*80, buf_upper*4, 
     :        f_avg*70, f_env*70, cmnts2skip(30)*79

      character f_ctl*40
      logical f_ctl_exist, f_env_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr=env2avg.CTL;'//
     :    ' ctl-brk to quit): '
        read(*, '(a)') f_ctl
        if (f_ctl(1:4) .eq. '    ') f_ctl = 'env2avg.ctl'
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') ' ******* FILE DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)

      f_avg = ' '
      read(nu_ctl,'(a)') f_avg
      call trim_c(f_avg,nc_f_avg)
      call get_lun(nu_avg)
      open(unit=nu_avg,file=f_avg(1:nc_f_avg),status='unknown')

      call skipcmnt(nu_ctl,cmnts2skip,nc_cmnts2skip)

      num_files = 0

1000  continue
      buf = ' '
      read(nu_ctl,'(a)',end = 9999) buf
      call trim_c(buf,nc_buf)
      buf_upper = ' '
      buf_upper = buf(1:4)
      call upstr(buf_upper)
      if(nc_buf .eq. 0 .or. buf(1:1) .eq. '!') go to 1000
      if(buf_upper(1:4) .eq. 'STOP') go to 8888  ! finish computing averages

      f_env = ' '
      f_env = buf(1:nc_buf)
      nc_f_env = nc_buf     
      inquire(file=f_env(1:nc_f_env), exist=f_env_exist)
      if (.not. f_env_exist) then
          write(*,'(a)') ' ****** FILE '//f_env(1:nc_f_env)// 
     :          ' DOES NOT EXIST; SKIPPING!!! ******* '
          go to 1000
      end if

* Passed tests; proceed

      num_files = num_files + 1

      call get_lun(nu_env)
      open(nu_env, file = f_env(1:nc_f_env), status='unknown')      

      call skipcmnt(nu_env,cmnts2skip,nc_cmnts2skip)

      read(nu_env,*) idum1, nout

      call skip(nu_env,2)

      allocate( env(nout) )

      if (num_files .eq. 1) then  ! allocate array in which average is accum.
        allocate( time_1(nout), avg(nout) )
        nout_1 = nout
        do i = 1, nout_1
          avg(i) = 0.0  ! initialize average
        end do
      end if      

      if (nout .ne. nout_1) then
        write(*,'(a,1x,i6,a,1x,i6,a)') 
     :    ' TROUBLE, NOUT = ', nout, 
     :    ';  NOT EQUAL TO NOUT_1 = ', nout_1, ': SKIPPING'

        num_files = num_files - 1
        deallocate( env)
        close(nu_env)
        go to 1000
      end if

* Now read the data from the file:

      write(*,'(1x,a)') 
     :   'Processing file:'//f_env(1:nc_f_env)

      do i = 1, nout_1
        read(nu_env,*) time, ts, env(i)
        if (num_files .eq. 1) then
          time_1(i) = time
        end if
        if (time .ne. time_1(i)) then ! inequality of times, skip
          write(*,'(a,1p,1x,e12.5,a,1x,e12.5,a,1x,i6,a)') 
     :    ' TROUBLE, TIME = ', time, 
     :    ';  NOT EQUAL TO TIME_1 = ', time_1(i), ' FOR I = ', i,
     :    ': SKIPPING'
          num_files = num_files - 1
          deallocate( env)
          close(nu_env)
          go to 1000
        end if
        avg(i) = avg(i) + env(i)
      end do

      deallocate( env)
      close(nu_env)

      go to 1000

8888  continue

* Finish computation of final averages and write to nu_avg
      write(nu_avg,'(9x,a,6x,a)') 
     :   'time', 'avg_env'

      do i = 1, nout_1
        avg(i) = avg(i)/float(num_files)
        write(nu_avg,'(1p, 2(1x,e12.5))')  
     :  time_1(i), avg(i)
      end do 

9999  continue

      deallocate (time_1, avg)

      close(nu_avg)
      close(nu_ctl)

      stop
      end

      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\upstr.for'
      include '\forprogs\skip.for'
      include '\forprogs\skipcmnt.for'

       