* ------------------------------------------------------------------- TabsXpnd
      Program TabsXpnd

* Read a list of files from a control file and replace tab characters
* with a specified number of spaces.

* Here is a sample control file:
*! Control file for TabsXpnd
*! Replace each tab character with this number of spaces:
* 1
*! List of files:
*file1.txt
*file2.txt
* stop 


* Dates: 12/17/02 - Written by D. Boore

      character f_in*80, f_out*80, f_scr*80, c_stop*4

      character f_ctl*40, buf*80, buf_in*255, buf_out*255,
     :          comment(20)*80
      logical f_ctl_exist, f_in_exist, f_scr_exist, f_out_exist

      f_ctl_exist = .false.
      do while (.not. f_ctl_exist)
        f_ctl = ' '
        write(*, '(a\)') 
     :    ' Enter name of control file (cr = tabsxpnd.ctl): '
        read(*, '(a)') f_ctl
        if (f_ctl .eq. ' ') f_ctl = 'tabsxpnd.ctl'
        call trim_c(f_ctl,nc_f_ctl)
        inquire(file=f_ctl, exist=f_ctl_exist)
        if (.not. f_ctl_exist) then
          write(*,'(a)') 
     :            ' ******* FILE '//f_ctl(1:nc_f_ctl)//
     :            ' DOES NOT EXIST ******* '
        end if
      end do

      call get_lun(nu_ctl)
      open(unit=nu_ctl,file=f_ctl,status='unknown')

      call skipcmnt(nu_ctl, comment, ncomments)
      read(nu_ctl,*) nspaces

      write(*,'(a,1x,i4)') ' nspaces = ', nspaces

      call skipcmnt(nu_ctl, comment, ncomments)

222   continue
      
      buf = ' '
      read(nu_ctl,'(a)') buf
      call trim_c(buf, nc_buf)
      c_stop = ' '
      c_stop = buf(1:4)
      call upstr(c_stop)
      if (c_stop .eq. 'STOP') then
        close(nu_ctl)
        stop
      end if

      f_in = ' '
      f_in = buf(1:nc_buf)
      call trim_c(f_in,nc_f_in)

* Check for existence of f_in:
      f_in_exist = .false.
      inquire(file=f_in, exist=f_in_exist)

      write(*,'(a)') ' f_in, f_in_exist = '//f_in
      write(*,*) f_in_exist

      if (.not. f_in_exist) then
        write(*,'(a)') ' File '//f_in(1:nc_buf)//
     :   ' does not exist; returning to control file'
        go to 222
      end if

      call get_lun(nu_in)
      open(unit=nu_in,file=f_in(1:nc_f_in), status='unknown')
      write(*,'(a)') ' Looking for tabs in file '//f_in(1:nc_f_in)

* Check for existence of f_scr, and delete if it exists:
      f_scr = ' '
      f_scr = 'scratch.out'
      call trim_c(f_scr,nc_f_scr)
      f_scr_exist = .false.
      inquire(file=f_scr, exist=f_scr_exist)
      if (f_scr_exist) then
        call system('del '//f_scr(1:nc_f_scr))
      end if

      call get_lun(nu_scr)
      open(unit=nu_scr,file=f_scr, status='unknown')

1000  continue
      buf_in = ' '
      read(nu_in, '(a)', end = 2000) buf_in
      call trim_c(buf_in, nc_buf_in)

      buf_out = ' '

      n_char = 0
      n_col = 1
      do i = 1, nc_buf_in
        if (ichar(buf_in(i:i)) .ne. 9) then  ! not a tab
          n_char = n_char + 1
          buf_out(n_char:n_char) = buf_in(i:i)
        else
          do j = 1, nspaces
            n_char = n_char + 1
            buf_out(n_char:n_char) = ' '
          end do
        end if
      end do 

      call trim_c(buf_out, nc_buf_out)
      write(nu_scr,'(a)') buf_out(1:nc_buf_out)

      goto 1000
2000  continue

      close(nu_in)
      close(nu_scr)

      iflag = 0
      if (iflag .eq. 1) then
        stop
      end if

* Copy scratch.out to f_out, delete scratch.out:

      f_out = f_in(1:nc_f_in)
      call trim_c(f_out,nc_f_out)
      
      f_out_exist = .false.
      inquire(file=f_out, exist=f_out_exist)
      if (f_out_exist) then
        call system('del '//f_out(1:nc_f_out))
      end if
      call system('copy '//f_scr(1:nc_f_scr)//' '//f_out(1:nc_f_out))
      call system('del '//f_scr(1:nc_f_scr))

      go to 222

      end
* ------------------------------------------------------------------- TabsXpnd


      include '\forprogs\get_lun.for'
      include '\forprogs\trim_c.for'
      include '\forprogs\upstr.for'
      include '\forprogs\skipcmnt.for'
      include '\forprogs\tab_xpnd.for'

